"""
------------------------------------------------------------------------------
           Name: test_recive_sms.py
         Author: Daniele De Santis (desantis@areasx.com)
        Version: 1.0
  Last Modified: 15/01/07
    Description: Test Ricezione SMS
                 Esempio in Python 1.5 per Modem TELIT GM862-PY su SxPY.
          Note : 
------------------------------------------------------------------------------
"""

import MDM
import GPIO
import MOD
import sys

#SETTO LA DIREZIONE DEI PORT
r=GPIO.setIOdir(2,0,1) #LED TEST
r=GPIO.setIOdir(6,0,1) #RELE' K1
r=GPIO.setIOdir(7,0,1) #RELE' K2
r=GPIO.setIOdir(1,0,0) #INPUT 1
r=GPIO.setIOdir(8,0,0) #INPUT 2 e PULSANTE TEST

#-------------------------
# FUNZIONI
#-------------------------

#Verifica la presenza e inizializza il modem
def InitModem():
  res = MDM.send('AT\r', 0) #Invio comando AT
  res = MDM.receive(3) #Attendo 3 sec
  if(res.find('OK') == -1): #RNONicevuto "OK"
    return -1
  #Attivo la modalit TEXT
  res = MDM.send("AT+CMGF=1\r", 0) #Invio comando AT
  res = MDM.receive(3) #Attendo 3 sec
  if(res.find('OK') == -1): #NON Ricevuto "OK"
    return -2
  else:
    return 1
    
#Legge un SMS 
def ReadSMS(ID):
  TXbuff="AT+CMGR=%d\r" % (ID)
  res = MDM.send(TXbuff, 0)
  res = MDM.receive(2)
  if(res.find('321') != -1): #Posizione vuota
    return 0
  if(res.find('OK') != -1): #trovato SMS
    #Parser dell'SMS
    smsHeader = res.split("\r\n")[1] #Intestazione
    dateSMS = smsHeader.split(",")[3].replace("\"", "") + " " + smsHeader.split(",")[4].replace("\"", "")
    #Struttura NUMERO GSM, DATA ORA, TESTO SMS
    SMS = (ID, smsHeader.split(",")[1].replace("\"", ""), dateSMS, res.split("\r\n")[2])
    return SMS
  return 0
  

#-------------------------
#FINE FUNZIONI
#-------------------------


#-------------------------
# PROGRAMMA PRINCIPALE
#-------------------------
print "\r\nTEST RICEZIONE SMS\r\n"

res= InitModem()
for i in range(1,10):
  if(res!=1):
    print "ERRORE inizializzazione del modem fallita. CODE %d\r\n" % res
  else:
    print "Inizializzazione Modem OK\r\n"
    break
    
if(res!=1):
  sys.exit(0)
index=1
while(1):
  res=""
  #print "Lettura locazione: %d\r\n" % (index)
  res = ReadSMS(index)
  
  if (res and len(res)==4):
    print "SMS Valido-------------\r\n"
    print "ID %d\r\n" % (res[0])
    print "NUMERO GSM %s\r\n" % (res[1])
    print "DATA ORA %s\r\n" % (res[2])
    print "MESSAGGIO %s\r\n" % (res[3])
  index = index +1
  if (index>10): index=1
  